using System;
using System.Collections.Generic;
using System.Text;

namespace AsynchCalcPi2005
{
    class AsyncCalcPiForm6_Thread5_Async3_Stop : AsyncCalcPiForm5_Thread4_Async2_Safe
    {
        public AsyncCalcPiForm6_Thread5_Async3_Stop()
            : base()
        {
            this.Text = "Thread:Async:Stop";
        }

        override protected void CalcPi(int digits)
        {
            StringBuilder pi = new StringBuilder("3", digits + 2);

            ShowProgressDelegate showProgress =
                new ShowProgressDelegate(ShowProgress);


            this.Invoke(
                showProgress,
                new object[] { pi.ToString(), digits, 0 });

            if (digits > 0)
            {
                pi.Append(".");

                for (int i = 0; i < digits; i += 9)
                {
                    int nineDigits = NineDigitsOfPi.StartingAt(i + 1);
                    int digitCount = Math.Min(digits - i, 9);
                    string ds = string.Format("{0:D9}", nineDigits);
                    pi.Append(ds.Substring(0, digitCount));

                    try
                    {
                        if (!(bool)this.Invoke(
                            showProgress,
                            new object[] { pi.ToString(), digits, i + digitCount }))
                        {
                            //form was closed, but operation is still running
                            Console.WriteLine("Still going null...");
                            //end loop
                            break;
                        }
                    }
                    catch (ObjectDisposedException)
                    {
                        //form was closed, but operation is still running
                        Console.WriteLine("Still going dispose...");
                        //end loop
                        break;
                    }
                    catch (InvalidOperationException)
                    {
                        //form was closed, but operation is still running
                        Console.WriteLine("Still going invalid...");
                        //Should never get here because of previous catch block.
                        break;
                    }
                }

            }
        }
    }
}
